/*
    Program, ktery realizuje jednoduchou evidenci osob.
    Informace o jednotlivych osobach jsou ukladany do
    binarniho souboru.

    Poznamka: Prijmeni je povazovano za jednoznacny klic.
*/

#include <stdio.h>
#include <string.h>

#define FILENAME "data.dat"

typedef struct osoba
{
    char jmeno[10], prijmeni[15];
    unsigned short vek;
} typOsoba;

void menu(void)
{
    puts("      K A R T O T E K A");
    puts("------------------------------");
    puts("1. Pridej osobu");
    puts("2. Vypis vsechny osoby");
    puts("3. Vymaz osobu");
    puts("4. Export do textoveho souboru");
    puts("5. Zaloz novou kartoteku");
    puts("6. Konec");
    puts("------------------------------");
    printf("Zvol operaci: ");
}

void pridej(FILE *f)
{
    typOsoba clovek;

    fflush(f);
    printf("\nZadej jmeno   : ");
    scanf("%9s",clovek.jmeno);
    printf("Zadej prijmeni: ");
    scanf("%14s",clovek.prijmeni);
    printf("Zadej vek     : ");
    scanf("%hu",&clovek.vek);
    fwrite(&clovek,sizeof(typOsoba),1,f);
    printf("\n");
}

void vypis(FILE *f)
{
    typOsoba clovek;
    unsigned int i;

    puts("\nC. Jmeno      Prijmeni       Vek");
    puts("--------------------------------");
    i=0;
    rewind(f);
    while (fread(&clovek,sizeof(typOsoba),1,f)==1)
    {
      i++;
      printf("%2u %-10s %-15s%3hu\n",i,clovek.jmeno,clovek.prijmeni,clovek.vek);
    }
    printf("\n");
}

void vymaz(FILE *f)
{
    typOsoba clovek;
    FILE *tmp;
    char prijmeni[15];

    printf("\nZadej prijmeni: ");
    scanf("%14s",prijmeni);

    tmp=fopen("data.tmp","wb");
    rewind(f);
    while (fread(&clovek,sizeof(typOsoba),1,f)==1)
      if (strcmp(clovek.prijmeni,prijmeni))
         fwrite(&clovek,sizeof(typOsoba),1,tmp);
    fclose(tmp);
    fclose(f);

    remove(FILENAME);
    rename("data.tmp",FILENAME);
    f=fopen(FILENAME,"a+b");

    printf("\n");
}

void exportuj(FILE *f)
{
    typOsoba clovek;
    FILE *txt;
    char jmeno[100];

    printf("\nZadej jmeno souboru: ");
    scanf("%99s",jmeno);

    txt=fopen(jmeno,"w");
    rewind(f);
    while (fread(&clovek,sizeof(typOsoba),1,f)==1)
      fprintf(txt,"%s,%s,%hu\n",clovek.jmeno,clovek.prijmeni,clovek.vek);
    fclose(txt);

    printf("\n");
}

void nova(FILE *f)
{
    fclose(f);
    remove(FILENAME);
    f=fopen(FILENAME,"a+b");
    printf("\n");
}

int main(void)
{
    FILE *soubor;
    int c;

    soubor=fopen(FILENAME,"a+b");

    do
    {
      menu();
      c=getchar();
      switch (c)
      {
        case '1': pridej(soubor);
                  break;
        case '2': vypis(soubor);
                  break;
        case '3': vymaz(soubor);
                  break;
        case '4': exportuj(soubor);
                  break;
        case '5': nova(soubor);
                  break;
      }
      while (getchar()!='\n');
    }
    while (c!='6');

    fclose(soubor);

    return 0;
}
